clear
clc

################
### Item (a) ###
################

f=@(x) 0.9 - (1+x+(x^2)/2)*exp(-x); #definindo a função
df=@(x) -(1+x)*exp(-x) + (1+x+(x^2)/2)*exp(-x); #definindo a derivada

#laço for para procurar uma aproximação para a função
#depois de executar e encontrar o zero, ele pode ser comentado
##for i=0:10
##  fprintf('f(%d)=%f \n',i,f(i))
##endfor

## f tem uma raiz entre 1 e 2

x = 1.5; #essa variável vai armazenar a resposta do primeiro item

while abs(f(x))>=10^(-8)
  x = x - f(x)/df(x);
endwhile

fprintf('(a) T_0,1 = %.9f, com erro |f(x)|=%.9e \n',x,abs(f(x)))
# No segundo valor em vez de usar %.9f eu usei %.9e,
# para que o valor seja apresentado em notação científica

################
### Item (b) ###
################

g=@(x) 0.1 - (1+x+(x^2)/2)*exp(-x); #definindo a função
dg=@(x) -(1+x)*exp(-x) + (1+x+(x^2)/2)*exp(-x); #definindo a derivada

#poderia ter definido novamente uma função f, que iria substituir a outra,
#mas como é uma nova função eu optei por definir com outra letra

#laço for para procurar uma aproximação para a função
#depois de executar e encontrar o zero, ele pode ser comentado
##for i=0:10
##  fprintf('g(%d)=%f \n',i,g(i))
##endfor

## g tem uma raiz entre 5 e 6

y = 5.6; #essa variável vai armazenar a resposta do segundo item

while abs(g(y))>=10^(-8)
  y = y-g(y)/dg(y);
endwhile

fprintf('(b) T_0,9 = %.9f, com erro |g(y)|=%.9e \n',y,abs(g(y)))

################
### Item (c) ###
################

fprintf('(c) O tempo de subida é %.9f \n',y-x)
